[CCode (cheader_filename = "ccode/valaccodeassignment.h")]
namespace Vala {
	public class CCodeAssignment : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_assignment_new")]
		public construct (Vala.CCodeExpression l, Vala.CCodeExpression r, Vala.CCodeAssignmentOperator op = CCodeAssignmentOperator.SIMPLE);
		public Vala.CCodeExpression left { get; construct; }
		public weak Vala.CCodeAssignmentOperator operator { get; set; }
		public Vala.CCodeExpression right { get; construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeassignment.h")]
namespace Vala {
	[CCode (cprefix = "VALA_CCODE_ASSIGNMENT_OPERATOR_")]
	public enum CCodeAssignmentOperator {
		SIMPLE,
		BITWISE_OR,
		BITWISE_AND,
		BITWISE_XOR,
		ADD,
		SUB,
		MUL,
		DIV,
		PERCENT,
		SHIFT_LEFT,
		SHIFT_RIGHT,
	}
}
[CCode (cheader_filename = "ccode/valaccodebinaryexpression.h")]
namespace Vala {
	public class CCodeBinaryExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_binary_expression_new")]
		public construct (Vala.CCodeBinaryOperator op, Vala.CCodeExpression! l, Vala.CCodeExpression! r);
		public weak Vala.CCodeBinaryOperator operator { get; set; }
		public Vala.CCodeExpression left { get; set construct; }
		public Vala.CCodeExpression right { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodebinaryexpression.h")]
namespace Vala {
	[CCode (cprefix = "VALA_CCODE_BINARY_OPERATOR_")]
	public enum CCodeBinaryOperator {
		PLUS,
		MINUS,
		MUL,
		DIV,
		MOD,
		SHIFT_LEFT,
		SHIFT_RIGHT,
		LESS_THAN,
		GREATER_THAN,
		LESS_THAN_OR_EQUAL,
		GREATER_THAN_OR_EQUAL,
		EQUALITY,
		INEQUALITY,
		BITWISE_AND,
		BITWISE_OR,
		BITWISE_XOR,
		AND,
		OR,
	}
}
[CCode (cheader_filename = "ccode/valaccodeblock.h")]
namespace Vala {
	public class CCodeBlock : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_block_prepend_statement")]
		public void prepend_statement (Vala.CCodeNode! statement);
		[CCode (cname = "vala_ccode_block_add_statement")]
		public void add_statement (Vala.CCodeNode! statement);
		public weak bool suppress_newline { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodebreakstatement.h")]
namespace Vala {
	public class CCodeBreakStatement : Vala.CCodeStatement {
	}
}
[CCode (cheader_filename = "ccode/valaccodecasestatement.h")]
namespace Vala {
	public class CCodeCaseStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_case_statement_new")]
		public construct (Vala.CCodeExpression! expr);
		[CCode (cname = "vala_ccode_case_statement_add_statement")]
		public void add_statement (Vala.CCodeStatement! stmt);
		public Vala.CCodeExpression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodecastexpression.h")]
namespace Vala {
	public class CCodeCastExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_cast_expression_new")]
		public construct (Vala.CCodeExpression! expr, string! type);
		public Vala.CCodeExpression inner { get; set construct; }
		public string type_name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodecommaexpression.h")]
namespace Vala {
	public class CCodeCommaExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_comma_expression_append_expression")]
		public void append_expression (Vala.CCodeExpression! expr);
	}
}
[CCode (cheader_filename = "ccode/valaccodecomment.h")]
namespace Vala {
	public class CCodeComment : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_comment_new")]
		public construct (string! _text);
		public string text { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeconditionalexpression.h")]
namespace Vala {
	public class CCodeConditionalExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_conditional_expression_new")]
		public construct (Vala.CCodeExpression! cond, Vala.CCodeExpression! true_expr, Vala.CCodeExpression! false_expr);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeExpression true_expression { get; set construct; }
		public Vala.CCodeExpression false_expression { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeconstant.h")]
namespace Vala {
	public class CCodeConstant : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_constant_new")]
		public construct (string! _name);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodecontinuestatement.h")]
namespace Vala {
	public class CCodeContinueStatement : Vala.CCodeStatement {
	}
}
[CCode (cheader_filename = "ccode/valaccodedeclaration.h")]
namespace Vala {
	public class CCodeDeclaration : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_declaration_new")]
		public construct (string! _type_name);
		[CCode (cname = "vala_ccode_declaration_add_declarator")]
		public void add_declarator (Vala.CCodeDeclarator! decl);
		public string type_name { get; set construct; }
		public weak Vala.CCodeModifiers modifiers { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodedeclarator.h")]
namespace Vala {
	public abstract class CCodeDeclarator : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "ccode/valaccodedostatement.h")]
namespace Vala {
	public class CCodeDoStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_do_statement_new")]
		public construct (Vala.CCodeStatement stmt, Vala.CCodeExpression! cond);
		public Vala.CCodeStatement body { get; set; }
		public Vala.CCodeExpression condition { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeemptystatement.h")]
namespace Vala {
	public class CCodeEmptyStatement : Vala.CCodeStatement {
	}
}
[CCode (cheader_filename = "ccode/valaccodeenum.h")]
namespace Vala {
	public class CCodeEnum : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_enum_new")]
		public construct (string n = null);
		[CCode (cname = "vala_ccode_enum_add_value")]
		public void add_value (string! name, string value = null);
		public string name { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeexpression.h")]
namespace Vala {
	public abstract class CCodeExpression : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "ccode/valaccodeexpressionstatement.h")]
namespace Vala {
	public class CCodeExpressionStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_expression_statement_new")]
		public construct (Vala.CCodeExpression expr);
		public Vala.CCodeExpression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeformalparameter.h")]
namespace Vala {
	public class CCodeFormalParameter : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_formal_parameter_new")]
		public construct (string! n, string! type);
		public string name { get; set construct; }
		public string type_name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeforstatement.h")]
namespace Vala {
	public class CCodeForStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_for_statement_new")]
		public construct (Vala.CCodeExpression! cond, Vala.CCodeStatement stmt = null);
		[CCode (cname = "vala_ccode_for_statement_add_initializer")]
		public void add_initializer (Vala.CCodeExpression! expr);
		[CCode (cname = "vala_ccode_for_statement_add_iterator")]
		public void add_iterator (Vala.CCodeExpression! expr);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeStatement body { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodefragment.h")]
namespace Vala {
	public class CCodeFragment : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_fragment_append")]
		public void append (Vala.CCodeNode! node);
		[CCode (cname = "vala_ccode_fragment_get_children")]
		public ref GLib.List get_children ();
	}
}
[CCode (cheader_filename = "ccode/valaccodefunction.h")]
namespace Vala {
	public class CCodeFunction : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_function_new")]
		public construct (string! _name, string! _return_type);
		[CCode (cname = "vala_ccode_function_add_parameter")]
		public void add_parameter (Vala.CCodeFormalParameter! param);
		[CCode (cname = "vala_ccode_function_copy")]
		public ref Vala.CCodeFunction! copy ();
		public string name { get; set construct; }
		public weak Vala.CCodeModifiers modifiers { get; set; }
		public string return_type { get; set construct; }
		public Vala.CCodeBlock block { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodefunctioncall.h")]
namespace Vala {
	public class CCodeFunctionCall : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_function_call_new")]
		public construct (Vala.CCodeExpression _call = null);
		[CCode (cname = "vala_ccode_function_call_add_argument")]
		public void add_argument (Vala.CCodeExpression! expr);
		public Vala.CCodeExpression call { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodefunctiondeclarator.h")]
namespace Vala {
	public class CCodeFunctionDeclarator : Vala.CCodeDeclarator {
		[CCode (cname = "vala_ccode_function_declarator_new")]
		public construct (string! n);
		[CCode (cname = "vala_ccode_function_declarator_add_parameter")]
		public void add_parameter (Vala.CCodeFormalParameter! param);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeidentifier.h")]
namespace Vala {
	public class CCodeIdentifier : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_identifier_new")]
		public construct (string! _name);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeifstatement.h")]
namespace Vala {
	public class CCodeIfStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_if_statement_new")]
		public construct (Vala.CCodeExpression! cond, Vala.CCodeStatement! true_stmt, Vala.CCodeStatement false_stmt = null);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeStatement true_statement { get; set construct; }
		public Vala.CCodeStatement false_statement { get; set construct; }
		public weak bool else_if { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeincludedirective.h")]
namespace Vala {
	public class CCodeIncludeDirective : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_include_directive_new")]
		public construct (string! _filename, bool _local = false);
		public string filename { get; set construct; }
		public weak bool local { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeinitializerlist.h")]
namespace Vala {
	public class CCodeInitializerList : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_initializer_list_append")]
		public void append (Vala.CCodeExpression! expr);
	}
}
[CCode (cheader_filename = "ccode/valaccodelinedirective.h")]
namespace Vala {
	public class CCodeLineDirective : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_line_directive_new")]
		public construct (string! _filename, int _line);
		public string filename { get; set construct; }
		public weak int line { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodemacroreplacement.h")]
namespace Vala {
	public class CCodeMacroReplacement : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_macro_replacement_new")]
		public construct (string! n, string! replace);
		public string name { get; set construct; }
		public string replacement { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodememberaccess.h")]
namespace Vala {
	public class CCodeMemberAccess : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_member_access_new")]
		public construct (Vala.CCodeExpression! container, string! member, bool pointer = false);
		[CCode (cname = "vala_ccode_member_access_new_pointer")]
		public construct pointer (Vala.CCodeExpression! container, string! member);
		public Vala.CCodeExpression inner { get; set construct; }
		public string member_name { get; set construct; }
		public weak bool is_pointer { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodemodifiers.h")]
namespace Vala {
	[CCode (cprefix = "VALA_CCODE_MODIFIERS_")]
	public enum CCodeModifiers {
		NONE,
		STATIC,
		REGISTER,
	}
}
[CCode (cheader_filename = "ccode/valaccodenewline.h")]
namespace Vala {
	public class CCodeNewline : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "ccode/valaccodenode.h")]
namespace Vala {
	public abstract class CCodeNode {
		[CCode (cname = "vala_ccode_node_write")]
		public abstract void write (Vala.CCodeWriter! writer);
		public Vala.CCodeLineDirective line { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeoncesection.h")]
namespace Vala {
	public class CCodeOnceSection : Vala.CCodeFragment {
		[CCode (cname = "vala_ccode_once_section_new")]
		public construct (string! def);
		public string define { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeparenthesizedexpression.h")]
namespace Vala {
	public class CCodeParenthesizedExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_parenthesized_expression_new")]
		public construct (Vala.CCodeExpression! expr);
		public Vala.CCodeExpression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodereturnstatement.h")]
namespace Vala {
	public class CCodeReturnStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_return_statement_new")]
		public construct (Vala.CCodeExpression expr = null);
		public Vala.CCodeExpression return_expression { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodestatement.h")]
namespace Vala {
	public abstract class CCodeStatement : Vala.CCodeNode {
	}
}
[CCode (cheader_filename = "ccode/valaccodestruct.h")]
namespace Vala {
	public class CCodeStruct : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_struct_new")]
		public construct (string! n);
		[CCode (cname = "vala_ccode_struct_add_declaration")]
		public void add_declaration (Vala.CCodeDeclaration! decl);
		[CCode (cname = "vala_ccode_struct_add_field")]
		public void add_field (string! type_name, string! name);
		public string name { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeswitchstatement.h")]
namespace Vala {
	public class CCodeSwitchStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_switch_statement_new")]
		public construct (Vala.CCodeExpression! expr);
		[CCode (cname = "vala_ccode_switch_statement_add_case")]
		public void add_case (Vala.CCodeCaseStatement! case_stmt);
		public Vala.CCodeExpression expression { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodetypedefinition.h")]
namespace Vala {
	public class CCodeTypeDefinition : Vala.CCodeNode {
		[CCode (cname = "vala_ccode_type_definition_new")]
		public construct (string type, Vala.CCodeDeclarator decl);
		public string type_name { get; set; }
		public Vala.CCodeDeclarator declarator { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeunaryexpression.h")]
namespace Vala {
	public class CCodeUnaryExpression : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_unary_expression_new")]
		public construct (Vala.CCodeUnaryOperator op, Vala.CCodeExpression! expr);
		public weak Vala.CCodeUnaryOperator operator { get; set; }
		public Vala.CCodeExpression inner { get; set construct; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeunaryexpression.h")]
namespace Vala {
	[CCode (cprefix = "VALA_CCODE_UNARY_OPERATOR_")]
	public enum CCodeUnaryOperator {
		PLUS,
		MINUS,
		LOGICAL_NEGATION,
		BITWISE_COMPLEMENT,
		ADDRESS_OF,
		PREFIX_INCREMENT,
		PREFIX_DECREMENT,
		POSTFIX_INCREMENT,
		POSTFIX_DECREMENT,
	}
}
[CCode (cheader_filename = "ccode/valaccodevariabledeclarator.h")]
namespace Vala {
	public class CCodeVariableDeclarator : Vala.CCodeDeclarator {
		[CCode (cname = "vala_ccode_variable_declarator_new")]
		public construct (string! _name);
		[CCode (cname = "vala_ccode_variable_declarator_new_with_initializer")]
		public construct with_initializer (string! _name, Vala.CCodeExpression init);
		public string name { get; set construct; }
		public Vala.CCodeExpression initializer { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodewhilestatement.h")]
namespace Vala {
	public class CCodeWhileStatement : Vala.CCodeStatement {
		[CCode (cname = "vala_ccode_while_statement_new")]
		public construct (Vala.CCodeExpression! cond, Vala.CCodeStatement stmt = null);
		public Vala.CCodeExpression condition { get; set construct; }
		public Vala.CCodeStatement body { get; set; }
	}
}
[CCode (cheader_filename = "ccode/valaccodewriter.h")]
namespace Vala {
	public class CCodeWriter {
		[CCode (cname = "vala_ccode_writer_new")]
		public construct (string! _filename);
		[CCode (cname = "vala_ccode_writer_close")]
		public void close ();
		[CCode (cname = "vala_ccode_writer_write_indent")]
		public void write_indent ();
		[CCode (cname = "vala_ccode_writer_write_string")]
		public void write_string (string! s);
		[CCode (cname = "vala_ccode_writer_write_newline")]
		public void write_newline ();
		[CCode (cname = "vala_ccode_writer_write_begin_block")]
		public void write_begin_block ();
		[CCode (cname = "vala_ccode_writer_write_end_block")]
		public void write_end_block ();
		[CCode (cname = "vala_ccode_writer_write_comment")]
		public void write_comment (string! text);
		public string filename { get; construct; }
		public weak bool bol { get; }
	}
}
[CCode (cheader_filename = "ccode/valaccodeelementaccess.h")]
namespace Vala {
	public class CCodeElementAccess : Vala.CCodeExpression {
		[CCode (cname = "vala_ccode_element_access_new")]
		public construct (Vala.CCodeExpression! cont, Vala.CCodeExpression! i);
		public Vala.CCodeExpression container { get; set construct; }
		public Vala.CCodeExpression index { get; set construct; }
	}
}
